
;CodeVisionAVR C Compiler V1.25.2 Beta1 Standard
;(C) Copyright 1998-2006 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega8
;Program type           : Application
;Clock frequency        : 16.000000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega8
	#pragma AVRPART MEMORY PROG_FLASH 8192
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	RCALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	RCALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	RCALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "PWM7seg.vec"
	.INCLUDE "PWM7seg.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	RJMP _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*****************************************************
;       2 Chip type           : ATmega8
;       3 Program type        : Application
;       4 Clock frequency     : 16,000000 MHz
;       5 Memory model        : Small
;       6 External SRAM size  : 0
;       7 Data Stack size     : 256
;       8 *****************************************************/
;       9 
;      10 #include <mega8.h>
;      11 #include <delay.h>    
;      12 #include <stdlib.h>     
;      13 
;      14 #define ADC_VREF_TYPE 0x00
;      15 #define pause delay_ms(10);  //   7-  
;      16 unsigned int adc_data[5];     //    -   
_adc_data:
	.BYTE 0xA
;      17 unsigned int input_index=0;
;      18 signed int delta;            
;      19                         
;      20 unsigned int flagPuska=0, PWMnach,
;      21 
;      22 //   
;      23      k=99,  //    1  99                                            
;      24      PWMstart=0,  //    0  100 
_PWMstart:
	.BYTE 0x2
;      25      PauseP1pusk=0,  //    P1, .      
_PauseP1pusk:
	.BYTE 0x2
;      26      PauseP2pusk=0,  //    P2, .        
_PauseP2pusk:
	.BYTE 0x2
;      27      PausePWMpusk=100,  //   , .       1   
_PausePWMpusk:
	.BYTE 0x2
;      28      PauseP1stop=100,  //    P1, .      
_PauseP1stop:
	.BYTE 0x2
;      29      PauseP2stop=200,  //    P2, .       
_PauseP2stop:
	.BYTE 0x2
;      30      PausePWMstop=0;  //   , .      
_PausePWMstop:
	.BYTE 0x2
;      31 char InversP1=1,  //  0,   P1 
;      32      InversP2=1;  //  0,   P2 
_InversP2:
	.BYTE 0x1
;      33 //     
;      34      
;      35 unsigned int perem2, i;
_perem2:
	.BYTE 0x2
_i:
	.BYTE 0x2
;      36                       
;      37 void Display(void)
;      38 {           

	.CSEG
_Display:
;      39 //    
;      40 PORTB.0=0;
	CBI  0x18,0
;      41 PORTB.1=1;           
	SBI  0x18,1
;      42 perem2=adc_data[0]/1023.0*k;  //    
	LDS  R30,_adc_data
	LDS  R31,_adc_data+1
	RCALL SUBOPT_0x0
	RCALL SUBOPT_0x1
	MOVW R26,R30
	MOVW R24,R22
	MOVW R30,R12
	RCALL SUBOPT_0x0
	RCALL __MULF12
	RCALL __CFD1U
	STS  _perem2,R30
	STS  _perem2+1,R31
;      43 switch (perem2/10)
	RCALL SUBOPT_0x2
;      44  {
;      45   case 0: PORTD=0b10001100; PORTC.3=0;
	SBIW R30,0
	BRNE _0xC
	LDI  R30,LOW(140)
	RJMP _0x52
;      46   break;
;      47   case 1: PORTD=0b11111101; PORTC.3=0;
_0xC:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0xD
	LDI  R30,LOW(253)
	RJMP _0x52
;      48   break;
;      49   case 2: PORTD=0b01001100; PORTC.3=1;
_0xD:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0xE
	LDI  R30,LOW(76)
	OUT  0x12,R30
	SBI  0x15,3
;      50   break;
	RJMP _0xB
;      51   case 3: PORTD=0b01101100; PORTC.3=0;
_0xE:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0xF
	LDI  R30,LOW(108)
	RJMP _0x52
;      52   break;
;      53   case 4: PORTD=0b00111101; PORTC.3=0;
_0xF:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x10
	LDI  R30,LOW(61)
	RJMP _0x52
;      54   break;
;      55   case 5: PORTD=0b00101110; PORTC.3=0;
_0x10:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x11
	LDI  R30,LOW(46)
	RJMP _0x52
;      56   break;
;      57   case 6: PORTD=0b00001110; PORTC.3=0;
_0x11:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x12
	LDI  R30,LOW(14)
	RJMP _0x52
;      58   break;
;      59   case 7: PORTD=0b11111100; PORTC.3=0;
_0x12:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x13
	LDI  R30,LOW(252)
	RJMP _0x52
;      60   break;
;      61   case 8: PORTD=0b00001100; PORTC.3=0;
_0x13:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x14
	LDI  R30,LOW(12)
	RJMP _0x52
;      62   break;
;      63   case 9: PORTD=0b00101100; PORTC.3=0;
_0x14:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0xB
	LDI  R30,LOW(44)
_0x52:
	OUT  0x12,R30
	CBI  0x15,3
;      64  }  
_0xB:
;      65  pause  
	RCALL SUBOPT_0x3
;      66 //    
;      67 PORTB.0=1;
	SBI  0x18,0
;      68 PORTB.1=0;  
	CBI  0x18,1
;      69 switch (perem2-10*(perem2/10))
	RCALL SUBOPT_0x2
	LDI  R26,LOW(10)
	LDI  R27,HIGH(10)
	RCALL __MULW12U
	LDS  R26,_perem2
	LDS  R27,_perem2+1
	RCALL __SWAPW12
	RCALL SUBOPT_0x4
;      70 //switch ((adc_data*OborDvigatelya/1023)-10*((adc_data*OborDvigatelya/1023)/10))
;      71  {
;      72   case 0: PORTD=0b10001100; PORTC.3=0;
	SBIW R30,0
	BRNE _0x19
	LDI  R30,LOW(140)
	RJMP _0x53
;      73   break;
;      74   case 1: PORTD=0b11111101; PORTC.3=0;
_0x19:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x1A
	LDI  R30,LOW(253)
	RJMP _0x53
;      75   break;
;      76   case 2: PORTD=0b01001100; PORTC.3=1;
_0x1A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x1B
	LDI  R30,LOW(76)
	OUT  0x12,R30
	SBI  0x15,3
;      77   break;
	RJMP _0x18
;      78   case 3: PORTD=0b01101100; PORTC.3=0;
_0x1B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x1C
	LDI  R30,LOW(108)
	RJMP _0x53
;      79   break;
;      80   case 4: PORTD=0b00111101; PORTC.3=0;
_0x1C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x1D
	LDI  R30,LOW(61)
	RJMP _0x53
;      81   break;
;      82   case 5: PORTD=0b00101110; PORTC.3=0;
_0x1D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x1E
	LDI  R30,LOW(46)
	RJMP _0x53
;      83   break;
;      84   case 6: PORTD=0b00001110; PORTC.3=0;
_0x1E:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x1F
	LDI  R30,LOW(14)
	RJMP _0x53
;      85   break;
;      86   case 7: PORTD=0b11111100; PORTC.3=0;
_0x1F:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x20
	LDI  R30,LOW(252)
	RJMP _0x53
;      87   break;
;      88   case 8: PORTD=0b00001100; PORTC.3=0;
_0x20:
	CPI  R30,LOW(0x8)
	LDI  R26,HIGH(0x8)
	CPC  R31,R26
	BRNE _0x21
	LDI  R30,LOW(12)
	RJMP _0x53
;      89   break;
;      90   case 9: PORTD=0b00101100; PORTC.3=0;
_0x21:
	CPI  R30,LOW(0x9)
	LDI  R26,HIGH(0x9)
	CPC  R31,R26
	BRNE _0x18
	LDI  R30,LOW(44)
_0x53:
	OUT  0x12,R30
	CBI  0x15,3
;      91  }
_0x18:
;      92  pause
	RCALL SUBOPT_0x3
;      93 }
	RET
;      94                                    
;      95 void pusk(void)  //
;      96 {                           
_pusk:
;      97  //  ""   
;      98  PORTB.0=0;
	CBI  0x18,0
;      99  PORTB.1=1;           
	SBI  0x18,1
;     100  PORTD=0b10011100; PORTC.3=0;
	LDI  R30,LOW(156)
	OUT  0x12,R30
	CBI  0x15,3
;     101 
;     102  flagPuska=1;
	RCALL SUBOPT_0x5
	MOVW R8,R30
;     103 
;     104  if (PauseP1stop<PauseP2stop)
	RCALL SUBOPT_0x6
	BRSH _0x23
;     105  {
;     106   // 1 
;     107   delay_ms(PauseP1pusk);  //    P1
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x8
;     108   if (InversP1==1) {PORTC.1=1;}
	RCALL SUBOPT_0x9
	BRNE _0x24
	SBI  0x15,1
;     109   else {PORTC.1=0;}                       
	RJMP _0x25
_0x24:
	CBI  0x15,1
_0x25:
;     110 
;     111   delay_ms(PauseP2pusk-PauseP1pusk);  //    P2           
	LDS  R26,_PauseP1pusk
	LDS  R27,_PauseP1pusk+1
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x8
;     112   // 2
;     113   if (InversP2==1) {PORTC.2=1;}
	RCALL SUBOPT_0xB
	BRNE _0x26
	SBI  0x15,2
;     114   else {PORTC.2=0;}                      
	RJMP _0x27
_0x26:
	CBI  0x15,2
_0x27:
;     115   
;     116   delay_ms(PausePWMpusk);  //   
	RJMP _0x54
;     117   TCCR1A=0b00100011; //    2
;     118  }                                       
;     119  else
_0x23:
;     120  {
;     121   delay_ms(PauseP2pusk);  //    P2           
	RCALL SUBOPT_0xA
	RCALL SUBOPT_0x8
;     122   // 2
;     123   if (InversP2==1) {PORTC.2=1;}
	RCALL SUBOPT_0xB
	BRNE _0x29
	SBI  0x15,2
;     124   else {PORTC.2=0;}                      
	RJMP _0x2A
_0x29:
	CBI  0x15,2
_0x2A:
;     125 
;     126   // 1 
;     127   delay_ms(PauseP1pusk-PauseP2pusk);  //    P1
	LDS  R26,_PauseP2pusk
	LDS  R27,_PauseP2pusk+1
	RCALL SUBOPT_0x7
	RCALL SUBOPT_0x4
	RCALL SUBOPT_0x8
;     128   if (InversP1==1) {PORTC.1=1;}
	RCALL SUBOPT_0x9
	BRNE _0x2B
	SBI  0x15,1
;     129   else {PORTC.1=0;}           
	RJMP _0x2C
_0x2B:
	CBI  0x15,1
_0x2C:
;     130               
;     131   delay_ms(PausePWMpusk);  //   
_0x54:
	LDS  R30,_PausePWMpusk
	LDS  R31,_PausePWMpusk+1
	RCALL SUBOPT_0x8
;     132   TCCR1A=0b00100011; //    2
	LDI  R30,LOW(35)
	OUT  0x2F,R30
;     133  }
;     134 
;     135  while (PIND.2==0) {Display();}  //           
_0x2D:
	SBIC 0x10,2
	RJMP _0x2F
	RCALL _Display
	RJMP _0x2D
_0x2F:
;     136 }
	RET
;     137 
;     138 void stop(void)  //
;     139 {        
_stop:
;     140  if (flagPuska==1)
	RCALL SUBOPT_0x5
	CP   R30,R8
	CPC  R31,R9
	BREQ PC+2
	RJMP _0x30
;     141  {                         
;     142   //  ""   
;     143   PORTB.0=0;
	CBI  0x18,0
;     144   PORTB.1=1;           
	SBI  0x18,1
;     145   PORTD=0b10001110; PORTC.3=1;
	LDI  R30,LOW(142)
	OUT  0x12,R30
	SBI  0x15,3
;     146 
;     147   flagPuska=0;  
	CLR  R8
	CLR  R9
;     148   
;     149   delay_ms(PausePWMstop);  //   
	LDS  R30,_PausePWMstop
	LDS  R31,_PausePWMstop+1
	RCALL SUBOPT_0x8
;     150   if (PIND.2==0) {goto konec;}
	SBIS 0x10,2
	RJMP _0x32
;     151   TCCR1A=0b00000011;  //    2     
	LDI  R30,LOW(3)
	OUT  0x2F,R30
;     152 
;     153 //  TCCR0=0x00;  // 1
;     154  
;     155   if (PauseP1stop<PauseP2stop)
	RCALL SUBOPT_0x6
	BRSH _0x33
;     156   {
;     157    delay_ms(PauseP1stop);  //    P1
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0x8
;     158    if (PIND.2==0) {goto konec;}
	SBIS 0x10,2
	RJMP _0x32
;     159    // 1 
;     160    if (InversP1==1) {PORTC.1=0;}
	RCALL SUBOPT_0x9
	BRNE _0x35
	CBI  0x15,1
;     161    else {PORTC.1=1;}                       
	RJMP _0x36
_0x35:
	SBI  0x15,1
_0x36:
;     162                                         
;     163    //    P2
;     164    for (i=1; i<=((PauseP2stop-PauseP1stop)/100); i=i+1)
	RCALL SUBOPT_0xD
_0x38:
	LDS  R26,_PauseP1stop
	LDS  R27,_PauseP1stop+1
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0xF
	BRLO _0x39
;     165    {
;     166     delay_ms(100);  
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x8
;     167     if (PIND.2==0) {goto konec;}
	SBIS 0x10,2
	RJMP _0x32
;     168    }
	RCALL SUBOPT_0x10
	RJMP _0x38
_0x39:
;     169    // 2
;     170    if (InversP2==1) {PORTC.2=0;}
	RCALL SUBOPT_0xB
	BRNE _0x3B
	CBI  0x15,2
;     171    else {PORTC.2=1;}                      
	RJMP _0x3C
_0x3B:
	SBI  0x15,2
_0x3C:
;     172   }
;     173   else
	RJMP _0x3D
_0x33:
;     174   {
;     175    delay_ms(PauseP2stop);  //    P2
	RCALL SUBOPT_0xE
	RCALL SUBOPT_0x8
;     176    if (PIND.2==0) {goto konec;}
	SBIS 0x10,2
	RJMP _0x32
;     177    // 2
;     178    if (InversP2==1) {PORTC.2=0;}
	RCALL SUBOPT_0xB
	BRNE _0x3F
	CBI  0x15,2
;     179    else {PORTC.2=1;}                      
	RJMP _0x40
_0x3F:
	SBI  0x15,2
_0x40:
;     180    
;     181   //    P1
;     182    for (i=1; i<=((PauseP1stop-PauseP2stop)/100); i=i+1)
	RCALL SUBOPT_0xD
_0x42:
	LDS  R26,_PauseP2stop
	LDS  R27,_PauseP2stop+1
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xF
	BRLO _0x43
;     183    {
;     184     delay_ms(100);  
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL SUBOPT_0x8
;     185     if (PIND.2==0) {goto konec;}
	SBIS 0x10,2
	RJMP _0x32
;     186    }
	RCALL SUBOPT_0x10
	RJMP _0x42
_0x43:
;     187    // 1 
;     188    if (InversP1==1) {PORTC.1=0;}
	RCALL SUBOPT_0x9
	BRNE _0x45
	CBI  0x15,1
;     189    else {PORTC.1=1;}                       
	RJMP _0x46
_0x45:
	SBI  0x15,1
_0x46:
;     190   }  
_0x3D:
;     191      
;     192 //  TCCR0=0x05;  // 1
;     193  konec:;
_0x32:
;     194  }
;     195 }
_0x30:
	RET
;     196                
;     197 // Timer 0 overflow interrupt service routine
;     198 interrupt [TIM0_OVF] void timer0_ovf_isr(void)    //  15 
;     199 {
_timer0_ovf_isr:
	ST   -Y,R30
;     200 // Reinitialize Timer 0 value
;     201 TCNT0=0x15;
	LDI  R30,LOW(21)
	OUT  0x32,R30
;     202 // Place your code here  
;     203 ADCSRA.6=1; // 
	SBI  0x6,6
;     204 }
	LD   R30,Y+
	RETI
;     205 
;     206 // ADC interrupt service routine
;     207 interrupt [ADC_INT] void adc_isr(void)
;     208 {
_adc_isr:
	ST   -Y,R0
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     209 //unsigned int adc_data;
;     210 // Read the AD conversion result
;     211 adc_data[input_index]=ADCW;
	MOVW R30,R4
	RCALL SUBOPT_0x11
	ADD  R26,R30
	ADC  R27,R31
	IN   R30,0x4
	IN   R31,0x4+1
	ST   X+,R30
	ST   X,R31
;     212 // Place your code here  
;     213 
;     214 //OCR1B = adc_data;  //   
;     215 //if (input_index==0) {OCR1B=((1023.0-PWMnach)/1023.0)*adc_data[input_index]+PWMnach;}
;     216 
;     217 //    
;     218 if (input_index==0)
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x47
;     219   {
;     220    input_index=4;
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	MOVW R4,R30
;     221    // External Interrupt(s) initialization
;     222    // INT0: Off
;     223    // INT1: Off
;     224    MCUCR=0x00;}
	LDI  R30,LOW(0)
	OUT  0x35,R30
;     225 else 
	RJMP _0x48
_0x47:
;     226   {input_index=0;
	CLR  R4
	CLR  R5
;     227  // External Interrupt(s) initialization
;     228 // INT0: Off
;     229 // INT1: On
;     230 // INT1 Mode: Rising Edge
;     231 GICR|=0x80;
	IN   R30,0x3B
	ORI  R30,0x80
	OUT  0x3B,R30
;     232 MCUCR=0x0C;
	LDI  R30,LOW(12)
	OUT  0x35,R30
;     233 GIFR=0x80;}
	LDI  R30,LOW(128)
	OUT  0x3A,R30
_0x48:
;     234    
;     235 ADMUX=(0 | (ADC_VREF_TYPE & 0xff) )+input_index;
	MOVW R30,R4
	ADIW R30,0
	OUT  0x7,R30
;     236 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R0,Y+
	RETI
;     237       
;     238 // External Interrupt 1 service routine
;     239 interrupt [EXT_INT1] void ext_int1_isr(void)  //    
;     240 {
_ext_int1_isr:
	ST   -Y,R0
	ST   -Y,R1
	ST   -Y,R22
	ST   -Y,R23
	ST   -Y,R24
	ST   -Y,R25
	ST   -Y,R26
	ST   -Y,R27
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;     241 // Place your code here
;     242 if (input_index==0) {     
	MOV  R0,R4
	OR   R0,R5
	BRNE _0x49
;     243                      OCR1B=((1023.0-PWMnach)/1023.0)*adc_data[input_index]+PWMnach;
	MOVW R30,R10
	__GETD2N 0x447FC000
	RCALL SUBOPT_0x0
	RCALL __SWAPD12
	RCALL __SUBF12
	RCALL SUBOPT_0x1
	PUSH R23
	PUSH R22
	PUSH R31
	PUSH R30
	MOVW R30,R4
	RCALL SUBOPT_0x11
	ADD  R26,R30
	ADC  R27,R31
	RCALL __GETW1P
	POP  R26
	POP  R27
	POP  R24
	POP  R25
	RCALL SUBOPT_0x0
	RCALL __MULF12
	MOVW R26,R30
	MOVW R24,R22
	MOVW R30,R10
	RCALL SUBOPT_0x0
	RCALL __ADDF12
	RCALL __CFD1U
	OUT  0x28+1,R31
	OUT  0x28,R30
;     244                      //delta=adc_data[0]-adc_data[4];
;     245                      //if (delta>=0) {OCR1B=((1023.0-PWMnach)/1023.0)*(adc_data[4]/*+delta*/)+PWMnach;}
;     246                      //else {OCR1B=((1023.0-PWMnach)/1023.0)*(adc_data[4]/*+delta*/)+PWMnach;}  
;     247                     } 
;     248    // External Interrupt(s) initialization
;     249    // INT0: Off
;     250    // INT1: Off
;     251    MCUCR=0x00;                                 
_0x49:
	LDI  R30,LOW(0)
	OUT  0x35,R30
;     252 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R27,Y+
	LD   R26,Y+
	LD   R25,Y+
	LD   R24,Y+
	LD   R23,Y+
	LD   R22,Y+
	LD   R1,Y+
	LD   R0,Y+
	RETI
;     253 
;     254 void main(void)
;     255 {
_main:
;     256 // Input/Output Ports initialization
;     257 // Port B initialization
;     258 // Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
;     259 // State7=T State6=T State5=P State4=P State3=P State2=0 State1=1 State0=1 
;     260 PORTB=0x3B;
	LDI  R30,LOW(59)
	OUT  0x18,R30
;     261 DDRB=0x07;
	LDI  R30,LOW(7)
	OUT  0x17,R30
;     262 
;     263 // Port C initialization
;     264 // Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
;     265 // State6=P State5=P State4=T State3=0 State2=0 State1=0 State0=T 
;     266 PORTC=0x60;
	LDI  R30,LOW(96)
	OUT  0x15,R30
;     267 DDRC=0x0E;
	LDI  R30,LOW(14)
	OUT  0x14,R30
;     268 
;     269 // Port D initialization
;     270 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out 
;     271 // State7=0 State6=0 State5=0 State4=0 State3=P State2=P State1=0 State0=0 
;     272 PORTD=0x0C;
	LDI  R30,LOW(12)
	OUT  0x12,R30
;     273 DDRD=0xF3;
	LDI  R30,LOW(243)
	OUT  0x11,R30
;     274 
;     275 // Timer/Counter 0 initialization
;     276 // Clock source: System Clock
;     277 // Clock value: 15,625 kHz
;     278 TCCR0=0x05;
	LDI  R30,LOW(5)
	OUT  0x33,R30
;     279 TCNT0=0x15;
	LDI  R30,LOW(21)
	OUT  0x32,R30
;     280 
;     281 // Timer/Counter 1 initialization
;     282 // Clock source: System Clock
;     283 // Clock value: 16000,000 kHz
;     284 // Mode: Fast PWM top=03FFh
;     285 // OC1A output: Discon.
;     286 // OC1B output: Non-Inv.
;     287 // Noise Canceler: Off
;     288 // Input Capture on Falling Edge
;     289 // Timer 1 Overflow Interrupt: Off
;     290 // Input Capture Interrupt: Off
;     291 // Compare A Match Interrupt: Off
;     292 // Compare B Match Interrupt: Off
;     293 TCCR1A=0x03;
	LDI  R30,LOW(3)
	OUT  0x2F,R30
;     294 TCCR1B=0x09;
	LDI  R30,LOW(9)
	OUT  0x2E,R30
;     295 TCNT1H=0x00;
	LDI  R30,LOW(0)
	OUT  0x2D,R30
;     296 TCNT1L=0x00;
	OUT  0x2C,R30
;     297 ICR1H=0x00;
	OUT  0x27,R30
;     298 ICR1L=0x00;
	OUT  0x26,R30
;     299 OCR1AH=0x00;
	OUT  0x2B,R30
;     300 OCR1AL=0x00;
	OUT  0x2A,R30
;     301 
;     302 OCR1BH=0x00;
	OUT  0x29,R30
;     303 OCR1BL=0x00;
	OUT  0x28,R30
;     304 
;     305 // Timer/Counter 2 initialization
;     306 // Clock source: System Clock
;     307 // Clock value: Timer 2 Stopped
;     308 // Mode: Normal top=FFh
;     309 // OC2 output: Disconnected
;     310 ASSR=0x00;
	OUT  0x22,R30
;     311 TCCR2=0x00;
	OUT  0x25,R30
;     312 TCNT2=0x00;
	OUT  0x24,R30
;     313 OCR2=0x00;
	OUT  0x23,R30
;     314 
;     315 // External Interrupt(s) initialization
;     316 // INT0: Off
;     317 // INT1: Off
;     318 MCUCR=0x00;
	OUT  0x35,R30
;     319 
;     320 // Timer(s)/Counter(s) Interrupt(s) initialization
;     321 TIMSK=0x01;
	LDI  R30,LOW(1)
	OUT  0x39,R30
;     322 
;     323 // Analog Comparator initialization
;     324 // Analog Comparator: Off
;     325 // Analog Comparator Input Capture by Timer/Counter 1: Off
;     326 ACSR=0x80;
	LDI  R30,LOW(128)
	OUT  0x8,R30
;     327 SFIOR=0x00;
	LDI  R30,LOW(0)
	OUT  0x30,R30
;     328 
;     329 // ADC initialization
;     330 // ADC Clock frequency: 125,000 kHz
;     331 // ADC Voltage Reference: AREF pin
;     332 ADMUX=ADC_VREF_TYPE;
	OUT  0x7,R30
;     333 ADCSRA=0x8F;
	LDI  R30,LOW(143)
	OUT  0x6,R30
;     334 
;     335 // Global enable interrupts
;     336 #asm("sei")
	sei
;     337             
;     338 if (k<=0) {k=1;}
	MOV  R0,R12
	OR   R0,R13
	BRNE _0x4A
	RCALL SUBOPT_0x5
	MOVW R12,R30
;     339 if (k>=100) {k=99;}
_0x4A:
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CP   R12,R30
	CPC  R13,R31
	BRLO _0x4B
	LDI  R30,LOW(99)
	LDI  R31,HIGH(99)
	MOVW R12,R30
;     340 PWMnach=(1023.0/100.0)*PWMstart;
_0x4B:
	LDS  R30,_PWMstart
	LDS  R31,_PWMstart+1
	__GETD2N 0x4123AE14
	RCALL SUBOPT_0x0
	RCALL __MULF12
	RCALL __CFD1U
	MOVW R10,R30
;     341 
;     342 while (1)
_0x4C:
;     343       {
;     344       // Place your code here
;     345       Display();    
	RCALL _Display
;     346       if (PIND.2==0) {pusk();}
	SBIC 0x10,2
	RJMP _0x4F
	RCALL _pusk
;     347       else {stop();}
	RJMP _0x50
_0x4F:
	RCALL _stop
_0x50:
;     348 
;     349       }; 
	RJMP _0x4C
;     350 }       
_0x51:
	RJMP _0x51


;OPTIMIZER ADDED SUBROUTINE, CALLED 6 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0x0:
	CLR  R22
	CLR  R23
	RCALL __CDF1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x1:
	MOVW R26,R30
	MOVW R24,R22
	__GETD1N 0x447FC000
	RCALL __DIVF21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0x2:
	LDS  R26,_perem2
	LDS  R27,_perem2+1
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	RCALL __DIVW21U
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x3:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x4:
	SUB  R30,R26
	SBC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x5:
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:7 WORDS
SUBOPT_0x6:
	LDS  R30,_PauseP2stop
	LDS  R31,_PauseP2stop+1
	LDS  R26,_PauseP1stop
	LDS  R27,_PauseP1stop+1
	CP   R26,R30
	CPC  R27,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x7:
	LDS  R30,_PauseP1pusk
	LDS  R31,_PauseP1pusk+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 10 TIMES, CODE SIZE REDUCTION:16 WORDS
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x9:
	LDI  R30,LOW(1)
	CP   R30,R14
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xA:
	LDS  R30,_PauseP2pusk
	LDS  R31,_PauseP2pusk+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES, CODE SIZE REDUCTION:4 WORDS
SUBOPT_0xB:
	LDS  R26,_InversP2
	CPI  R26,LOW(0x1)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xC:
	LDS  R30,_PauseP1stop
	LDS  R31,_PauseP1stop+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0xD:
	RCALL SUBOPT_0x5
	STS  _i,R30
	STS  _i+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0xE:
	LDS  R30,_PauseP2stop
	LDS  R31,_PauseP2stop+1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:8 WORDS
SUBOPT_0xF:
	RCALL SUBOPT_0x4
	MOVW R26,R30
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	RCALL __DIVW21U
	LDS  R26,_i
	LDS  R27,_i+1
	CP   R30,R26
	CPC  R31,R27
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:6 WORDS
SUBOPT_0x10:
	LDS  R30,_i
	LDS  R31,_i+1
	ADIW R30,1
	STS  _i,R30
	STS  _i+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:1 WORDS
SUBOPT_0x11:
	LDI  R26,LOW(_adc_data)
	LDI  R27,HIGH(_adc_data)
	LSL  R30
	ROL  R31
	RET

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0xFA0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGD1:
	COM  R30
	COM  R31
	COM  R22
	COM  R23
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	SBCI R23,-1
	RET

__CWD1:
	MOV  R22,R31
	ADD  R22,R22
	SBC  R22,R22
	MOV  R23,R22
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__SWAPD12:
	MOV  R1,R24
	MOV  R24,R22
	MOV  R22,R1
	MOV  R1,R25
	MOV  R25,R23
	MOV  R23,R1

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__ROUND_REPACK:
	TST  R21
	BRPL __REPACK
	CPI  R21,0x80
	BRNE __ROUND_REPACK0
	SBRS R30,0
	RJMP __REPACK
__ROUND_REPACK0:
	ADIW R30,1
	ADC  R22,R25
	ADC  R23,R25
	BRVS __REPACK1

__REPACK:
	LDI  R21,0x80
	EOR  R21,R23
	BRNE __REPACK0
	PUSH R21
	RJMP __ZERORES
__REPACK0:
	CPI  R21,0xFF
	BREQ __REPACK1
	LSL  R22
	LSL  R0
	ROR  R21
	ROR  R22
	MOV  R23,R21
	RET
__REPACK1:
	PUSH R21
	TST  R0
	BRMI __REPACK2
	RJMP __MAXRES
__REPACK2:
	RJMP __MINRES

__UNPACK:
	LDI  R21,0x80
	MOV  R1,R25
	AND  R1,R21
	LSL  R24
	ROL  R25
	EOR  R25,R21
	LSL  R21
	ROR  R24

__UNPACK1:
	LDI  R21,0x80
	MOV  R0,R23
	AND  R0,R21
	LSL  R22
	ROL  R23
	EOR  R23,R21
	LSL  R21
	ROR  R22
	RET

__CFD1U:
	SET
	RJMP __CFD1U0
__CFD1:
	CLT
__CFD1U0:
	PUSH R21
	RCALL __UNPACK1
	CPI  R23,0x80
	BRLO __CFD10
	CPI  R23,0xFF
	BRCC __CFD10
	RJMP __ZERORES
__CFD10:
	LDI  R21,22
	SUB  R21,R23
	BRPL __CFD11
	NEG  R21
	CPI  R21,8
	BRTC __CFD19
	CPI  R21,9
__CFD19:
	BRLO __CFD17
	SER  R30
	SER  R31
	SER  R22
	LDI  R23,0x7F
	BLD  R23,7
	RJMP __CFD15
__CFD17:
	CLR  R23
	TST  R21
	BREQ __CFD15
__CFD18:
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R23
	DEC  R21
	BRNE __CFD18
	RJMP __CFD15
__CFD11:
	CLR  R23
__CFD12:
	CPI  R21,8
	BRLO __CFD13
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R23
	SUBI R21,8
	RJMP __CFD12
__CFD13:
	TST  R21
	BREQ __CFD15
__CFD14:
	LSR  R23
	ROR  R22
	ROR  R31
	ROR  R30
	DEC  R21
	BRNE __CFD14
__CFD15:
	TST  R0
	BRPL __CFD16
	RCALL __ANEGD1
__CFD16:
	POP  R21
	RET

__CDF1U:
	SET
	RJMP __CDF1U0
__CDF1:
	CLT
__CDF1U0:
	SBIW R30,0
	SBCI R22,0
	SBCI R23,0
	BREQ __CDF10
	CLR  R0
	BRTS __CDF11
	TST  R23
	BRPL __CDF11
	COM  R0
	RCALL __ANEGD1
__CDF11:
	MOV  R1,R23
	LDI  R23,30
	TST  R1
__CDF12:
	BRMI __CDF13
	DEC  R23
	LSL  R30
	ROL  R31
	ROL  R22
	ROL  R1
	RJMP __CDF12
__CDF13:
	MOV  R30,R31
	MOV  R31,R22
	MOV  R22,R1
	PUSH R21
	RCALL __REPACK
	POP  R21
__CDF10:
	RET

__SWAPACC:
	PUSH R20
	MOVW R20,R30
	MOVW R30,R26
	MOVW R26,R20
	MOVW R20,R22
	MOVW R22,R24
	MOVW R24,R20
	MOV  R20,R0
	MOV  R0,R1
	MOV  R1,R20
	POP  R20
	RET

__UADD12:
	ADD  R30,R26
	ADC  R31,R27
	ADC  R22,R24
	RET

__NEGMAN1:
	COM  R30
	COM  R31
	COM  R22
	SUBI R30,-1
	SBCI R31,-1
	SBCI R22,-1
	RET

__SUBF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129
	LDI  R21,0x80
	EOR  R1,R21

	RJMP __ADDF120

__ADDF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R25,0x80
	BREQ __ADDF129

__ADDF120:
	CPI  R23,0x80
	BREQ __ADDF128
__ADDF121:
	MOV  R21,R23
	SUB  R21,R25
	BRVS __ADDF129
	BRPL __ADDF122
	RCALL __SWAPACC
	RJMP __ADDF121
__ADDF122:
	CPI  R21,24
	BRLO __ADDF123
	CLR  R26
	CLR  R27
	CLR  R24
__ADDF123:
	CPI  R21,8
	BRLO __ADDF124
	MOV  R26,R27
	MOV  R27,R24
	CLR  R24
	SUBI R21,8
	RJMP __ADDF123
__ADDF124:
	TST  R21
	BREQ __ADDF126
__ADDF125:
	LSR  R24
	ROR  R27
	ROR  R26
	DEC  R21
	BRNE __ADDF125
__ADDF126:
	MOV  R21,R0
	EOR  R21,R1
	BRMI __ADDF127
	RCALL __UADD12
	BRCC __ADDF129
	ROR  R22
	ROR  R31
	ROR  R30
	INC  R23
	BRVC __ADDF129
	RJMP __MAXRES
__ADDF128:
	RCALL __SWAPACC
__ADDF129:
	RCALL __REPACK
	POP  R21
	RET
__ADDF127:
	SUB  R30,R26
	SBC  R31,R27
	SBC  R22,R24
	BREQ __ZERORES
	BRCC __ADDF1210
	COM  R0
	RCALL __NEGMAN1
__ADDF1210:
	TST  R22
	BRMI __ADDF129
	LSL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVC __ADDF1210

__ZERORES:
	CLR  R30
	CLR  R31
	CLR  R22
	CLR  R23
	POP  R21
	RET

__MINRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	SER  R23
	POP  R21
	RET

__MAXRES:
	SER  R30
	SER  R31
	LDI  R22,0x7F
	LDI  R23,0x7F
	POP  R21
	RET

__MULF12:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BREQ __ZERORES
	CPI  R25,0x80
	BREQ __ZERORES
	EOR  R0,R1
	SEC
	ADC  R23,R25
	BRVC __MULF124
	BRLT __ZERORES
__MULF125:
	TST  R0
	BRMI __MINRES
	RJMP __MAXRES
__MULF124:
	PUSH R0
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R17
	CLR  R18
	CLR  R25
	MUL  R22,R24
	MOVW R20,R0
	MUL  R24,R31
	MOV  R19,R0
	ADD  R20,R1
	ADC  R21,R25
	MUL  R22,R27
	ADD  R19,R0
	ADC  R20,R1
	ADC  R21,R25
	MUL  R24,R30
	RCALL __MULF126
	MUL  R27,R31
	RCALL __MULF126
	MUL  R22,R26
	RCALL __MULF126
	MUL  R27,R30
	RCALL __MULF127
	MUL  R26,R31
	RCALL __MULF127
	MUL  R26,R30
	ADD  R17,R1
	ADC  R18,R25
	ADC  R19,R25
	ADC  R20,R25
	ADC  R21,R25
	MOV  R30,R19
	MOV  R31,R20
	MOV  R22,R21
	MOV  R21,R18
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	POP  R0
	TST  R22
	BRMI __MULF122
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	RJMP __MULF123
__MULF122:
	INC  R23
	BRVS __MULF125
__MULF123:
	RCALL __ROUND_REPACK
	POP  R21
	RET

__MULF127:
	ADD  R17,R0
	ADC  R18,R1
	ADC  R19,R25
	RJMP __MULF128
__MULF126:
	ADD  R18,R0
	ADC  R19,R1
__MULF128:
	ADC  R20,R25
	ADC  R21,R25
	RET

__DIVF21:
	PUSH R21
	RCALL __UNPACK
	CPI  R23,0x80
	BRNE __DIVF210
	TST  R1
__DIVF211:
	BRPL __DIVF219
	RJMP __MINRES
__DIVF219:
	RJMP __MAXRES
__DIVF210:
	CPI  R25,0x80
	BRNE __DIVF218
__DIVF217:
	RJMP __ZERORES
__DIVF218:
	EOR  R0,R1
	SEC
	SBC  R25,R23
	BRVC __DIVF216
	BRLT __DIVF217
	TST  R0
	RJMP __DIVF211
__DIVF216:
	MOV  R23,R25
	PUSH R17
	PUSH R18
	PUSH R19
	PUSH R20
	CLR  R1
	CLR  R17
	CLR  R18
	CLR  R19
	CLR  R20
	CLR  R21
	LDI  R25,32
__DIVF212:
	CP   R26,R30
	CPC  R27,R31
	CPC  R24,R22
	CPC  R20,R17
	BRLO __DIVF213
	SUB  R26,R30
	SBC  R27,R31
	SBC  R24,R22
	SBC  R20,R17
	SEC
	RJMP __DIVF214
__DIVF213:
	CLC
__DIVF214:
	ROL  R21
	ROL  R18
	ROL  R19
	ROL  R1
	ROL  R26
	ROL  R27
	ROL  R24
	ROL  R20
	DEC  R25
	BRNE __DIVF212
	MOVW R30,R18
	MOV  R22,R1
	POP  R20
	POP  R19
	POP  R18
	POP  R17
	TST  R22
	BRMI __DIVF215
	LSL  R21
	ROL  R30
	ROL  R31
	ROL  R22
	DEC  R23
	BRVS __DIVF217
__DIVF215:
	RCALL __ROUND_REPACK
	POP  R21
	RET

;END OF CODE MARKER
__END_OF_CODE:
