/*****************************************************
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions



// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

/* CodeVisionAVR C Compiler
   Prototypes for standard library functions

   (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.
*/




#pragma used+

int atoi(char *str);
long int atol(char *str);
float atof(char *str);
void itoa(int n,char *str);
void ltoa(long int n,char *str);
void ftoa(float n,unsigned char decimals,char *str);
void ftoe(float n,unsigned char decimals,char *str);
void srand(int seed);
int rand(void);
void *malloc(unsigned int size);
void *calloc(unsigned int num, unsigned int size);
void *realloc(void *ptr, unsigned int size); 
void free(void *ptr);

#pragma used-
#pragma library stdlib.lib



unsigned int adc_data[5];     //    -   
unsigned int input_index=0;
signed int delta;            
                        
unsigned int flagPuska=0, PWMnach,

//   
     k=99,  //    1  99                                            
     PWMstart=0,  //    0  100 
     PauseP1pusk=0,  //    P1, .      
     PauseP2pusk=0,  //    P2, .        
     PausePWMpusk=100,  //   , .       1   
     PauseP1stop=100,  //    P1, .      
     PauseP2stop=200,  //    P2, .       
     PausePWMstop=0;  //   , .      
char InversP1=1,  //  0,   P1 
     InversP2=1;  //  0,   P2 
//     
     
unsigned int perem2, i;
                      
void Display(void)
{           
//    
PORTB.0=0;
PORTB.1=1;           
perem2=adc_data[0]/1023.0*k;  //    
switch (perem2/10)
 {
  case 0: PORTD=0b10001100; PORTC.3=0;
  break;
  case 1: PORTD=0b11111101; PORTC.3=0;
  break;
  case 2: PORTD=0b01001100; PORTC.3=1;
  break;
  case 3: PORTD=0b01101100; PORTC.3=0;
  break;
  case 4: PORTD=0b00111101; PORTC.3=0;
  break;
  case 5: PORTD=0b00101110; PORTC.3=0;
  break;
  case 6: PORTD=0b00001110; PORTC.3=0;
  break;
  case 7: PORTD=0b11111100; PORTC.3=0;
  break;
  case 8: PORTD=0b00001100; PORTC.3=0;
  break;
  case 9: PORTD=0b00101100; PORTC.3=0;
 }  
 delay_ms(10);    
//    
PORTB.0=1;
PORTB.1=0;  
switch (perem2-10*(perem2/10))
//switch ((adc_data*OborDvigatelya/1023)-10*((adc_data*OborDvigatelya/1023)/10))
 {
  case 0: PORTD=0b10001100; PORTC.3=0;
  break;
  case 1: PORTD=0b11111101; PORTC.3=0;
  break;
  case 2: PORTD=0b01001100; PORTC.3=1;
  break;
  case 3: PORTD=0b01101100; PORTC.3=0;
  break;
  case 4: PORTD=0b00111101; PORTC.3=0;
  break;
  case 5: PORTD=0b00101110; PORTC.3=0;
  break;
  case 6: PORTD=0b00001110; PORTC.3=0;
  break;
  case 7: PORTD=0b11111100; PORTC.3=0;
  break;
  case 8: PORTD=0b00001100; PORTC.3=0;
  break;
  case 9: PORTD=0b00101100; PORTC.3=0;
 }
 delay_ms(10);  
}
                                   
void pusk(void)  //
{                           
 //  ""   
 PORTB.0=0;
 PORTB.1=1;           
 PORTD=0b10011100; PORTC.3=0;

 flagPuska=1;

 if (PauseP1stop<PauseP2stop)
 {
  // 1 
  delay_ms(PauseP1pusk);  //    P1
  if (InversP1==1) {PORTC.1=1;}
  else {PORTC.1=0;}                       

  delay_ms(PauseP2pusk-PauseP1pusk);  //    P2           
  // 2
  if (InversP2==1) {PORTC.2=1;}
  else {PORTC.2=0;}                      
  
  delay_ms(PausePWMpusk);  //   
  TCCR1A=0b00100011; //    2
 }                                       
 else
 {
  delay_ms(PauseP2pusk);  //    P2           
  // 2
  if (InversP2==1) {PORTC.2=1;}
  else {PORTC.2=0;}                      

  // 1 
  delay_ms(PauseP1pusk-PauseP2pusk);  //    P1
  if (InversP1==1) {PORTC.1=1;}
  else {PORTC.1=0;}           
              
  delay_ms(PausePWMpusk);  //   
  TCCR1A=0b00100011; //    2
 }

 while (PIND.2==0) {Display();}  //           
}

void stop(void)  //
{        
 if (flagPuska==1)
 {                         
  //  ""   
  PORTB.0=0;
  PORTB.1=1;           
  PORTD=0b10001110; PORTC.3=1;

  flagPuska=0;  
  
  delay_ms(PausePWMstop);  //   
  if (PIND.2==0) {goto konec;}
  TCCR1A=0b00000011;  //    2     

//  TCCR0=0x00;  // 1
 
  if (PauseP1stop<PauseP2stop)
  {
   delay_ms(PauseP1stop);  //    P1
   if (PIND.2==0) {goto konec;}
   // 1 
   if (InversP1==1) {PORTC.1=0;}
   else {PORTC.1=1;}                       
                                        
   //    P2
   for (i=1; i<=((PauseP2stop-PauseP1stop)/100); i=i+1)
   {
    delay_ms(100);  
    if (PIND.2==0) {goto konec;}
   }
   // 2
   if (InversP2==1) {PORTC.2=0;}
   else {PORTC.2=1;}                      
  }
  else
  {
   delay_ms(PauseP2stop);  //    P2
   if (PIND.2==0) {goto konec;}
   // 2
   if (InversP2==1) {PORTC.2=0;}
   else {PORTC.2=1;}                      
   
  //    P1
   for (i=1; i<=((PauseP1stop-PauseP2stop)/100); i=i+1)
   {
    delay_ms(100);  
    if (PIND.2==0) {goto konec;}
   }
   // 1 
   if (InversP1==1) {PORTC.1=0;}
   else {PORTC.1=1;}                       
  }  
     
//  TCCR0=0x05;  // 1
 konec:;
 }
}
               
// Timer 0 overflow interrupt service routine
interrupt [10] void timer0_ovf_isr(void)    //  15 
{
// Reinitialize Timer 0 value
TCNT0=0x15;
// Place your code here  
ADCSRA.6=1; // 
}

// ADC interrupt service routine
interrupt [15] void adc_isr(void)
{
//unsigned int adc_data;
// Read the AD conversion result
adc_data[input_index]=ADCW;
// Place your code here  

//OCR1B = adc_data;  //   
//if (input_index==0) {OCR1B=((1023.0-PWMnach)/1023.0)*adc_data[input_index]+PWMnach;}

//    
if (input_index==0)
  {
   input_index=4;
   // External Interrupt(s) initialization
   // INT0: Off
   // INT1: Off
   MCUCR=0x00;}
else 
  {input_index=0;
 // External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Rising Edge
GICR|=0x80;
MCUCR=0x0C;
GIFR=0x80;}
   
ADMUX=(0 | (0x00 & 0xff) )+input_index;
}
      
// External Interrupt 1 service routine
interrupt [3] void ext_int1_isr(void)  //    
{
// Place your code here
if (input_index==0) {     
                     OCR1B=((1023.0-PWMnach)/1023.0)*adc_data[input_index]+PWMnach;
                     //delta=adc_data[0]-adc_data[4];
                     //if (delta>=0) {OCR1B=((1023.0-PWMnach)/1023.0)*(adc_data[4]/*+delta*/)+PWMnach;}
                     //else {OCR1B=((1023.0-PWMnach)/1023.0)*(adc_data[4]/*+delta*/)+PWMnach;}  
                    } 
   // External Interrupt(s) initialization
   // INT0: Off
   // INT1: Off
   MCUCR=0x00;                                 
}

void main(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=P State4=P State3=P State2=0 State1=1 State0=1 
PORTB=0x3B;
DDRB=0x07;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State6=P State5=P State4=T State3=0 State2=0 State1=0 State0=T 
PORTC=0x60;
DDRC=0x0E;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=P State2=P State1=0 State0=0 
PORTD=0x0C;
DDRD=0xF3;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x05;
TCNT0=0x15;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 16000,000 kHz
// Mode: Fast PWM top=03FFh
// OC1A output: Discon.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x03;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;

OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=0x00;
ADCSRA=0x8F;

// Global enable interrupts
#asm("sei")
            
if (k<=0) {k=1;}
if (k>=100) {k=99;}
PWMnach=(1023.0/100.0)*PWMstart;

while (1)
      {
      // Place your code here
      Display();    
      if (PIND.2==0) {pusk();}
      else {stop();}

      }; 
}       
