/*****************************************************
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 16,000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

#include <mega8.h>
#include <delay.h>    
#include <stdlib.h>     

#define ADC_VREF_TYPE 0x00
#define pause delay_ms(10);  //   7-  
unsigned int adc_data[5];     //    -   
unsigned int input_index=0;
signed int delta;            
                        
unsigned int flagPuska=0, PWMnach,

//   
     k=99,  //    1  99                                            
     PWMstart=0,  //    0  100 
     PauseP1pusk=0,  //    P1, .      
     PauseP2pusk=0,  //    P2, .        
     PausePWMpusk=100,  //   , .       1   
     PauseP1stop=100,  //    P1, .      
     PauseP2stop=200,  //    P2, .       
     PausePWMstop=0;  //   , .      
char InversP1=1,  //  0,   P1 
     InversP2=1;  //  0,   P2 
//     
     
unsigned int perem2, i;
                      
void Display(void)
{           
//    
PORTB.0=0;
PORTB.1=1;           
perem2=adc_data[0]/1023.0*k;  //    
switch (perem2/10)
 {
  case 0: PORTD=0b10001100; PORTC.3=0;
  break;
  case 1: PORTD=0b11111101; PORTC.3=0;
  break;
  case 2: PORTD=0b01001100; PORTC.3=1;
  break;
  case 3: PORTD=0b01101100; PORTC.3=0;
  break;
  case 4: PORTD=0b00111101; PORTC.3=0;
  break;
  case 5: PORTD=0b00101110; PORTC.3=0;
  break;
  case 6: PORTD=0b00001110; PORTC.3=0;
  break;
  case 7: PORTD=0b11111100; PORTC.3=0;
  break;
  case 8: PORTD=0b00001100; PORTC.3=0;
  break;
  case 9: PORTD=0b00101100; PORTC.3=0;
 }  
 pause  
//    
PORTB.0=1;
PORTB.1=0;  
switch (perem2-10*(perem2/10))
//switch ((adc_data*OborDvigatelya/1023)-10*((adc_data*OborDvigatelya/1023)/10))
 {
  case 0: PORTD=0b10001100; PORTC.3=0;
  break;
  case 1: PORTD=0b11111101; PORTC.3=0;
  break;
  case 2: PORTD=0b01001100; PORTC.3=1;
  break;
  case 3: PORTD=0b01101100; PORTC.3=0;
  break;
  case 4: PORTD=0b00111101; PORTC.3=0;
  break;
  case 5: PORTD=0b00101110; PORTC.3=0;
  break;
  case 6: PORTD=0b00001110; PORTC.3=0;
  break;
  case 7: PORTD=0b11111100; PORTC.3=0;
  break;
  case 8: PORTD=0b00001100; PORTC.3=0;
  break;
  case 9: PORTD=0b00101100; PORTC.3=0;
 }
 pause
}
                                   
void pusk(void)  //
{                           
 //  ""   
 PORTB.0=0;
 PORTB.1=1;           
 PORTD=0b10011100; PORTC.3=0;

 flagPuska=1;

 if (PauseP1stop<PauseP2stop)
 {
  // 1 
  delay_ms(PauseP1pusk);  //    P1
  if (InversP1==1) {PORTC.1=1;}
  else {PORTC.1=0;}                       

  delay_ms(PauseP2pusk-PauseP1pusk);  //    P2           
  // 2
  if (InversP2==1) {PORTC.2=1;}
  else {PORTC.2=0;}                      
  
  delay_ms(PausePWMpusk);  //   
  TCCR1A=0b00100011; //    2
 }                                       
 else
 {
  delay_ms(PauseP2pusk);  //    P2           
  // 2
  if (InversP2==1) {PORTC.2=1;}
  else {PORTC.2=0;}                      

  // 1 
  delay_ms(PauseP1pusk-PauseP2pusk);  //    P1
  if (InversP1==1) {PORTC.1=1;}
  else {PORTC.1=0;}           
              
  delay_ms(PausePWMpusk);  //   
  TCCR1A=0b00100011; //    2
 }

 while (PIND.2==0) {Display();}  //           
}

void stop(void)  //
{        
 if (flagPuska==1)
 {                         
  //  ""   
  PORTB.0=0;
  PORTB.1=1;           
  PORTD=0b10001110; PORTC.3=1;

  flagPuska=0;  
  
  delay_ms(PausePWMstop);  //   
  if (PIND.2==0) {goto konec;}
  TCCR1A=0b00000011;  //    2     

//  TCCR0=0x00;  // 1
 
  if (PauseP1stop<PauseP2stop)
  {
   delay_ms(PauseP1stop);  //    P1
   if (PIND.2==0) {goto konec;}
   // 1 
   if (InversP1==1) {PORTC.1=0;}
   else {PORTC.1=1;}                       
                                        
   //    P2
   for (i=1; i<=((PauseP2stop-PauseP1stop)/100); i=i+1)
   {
    delay_ms(100);  
    if (PIND.2==0) {goto konec;}
   }
   // 2
   if (InversP2==1) {PORTC.2=0;}
   else {PORTC.2=1;}                      
  }
  else
  {
   delay_ms(PauseP2stop);  //    P2
   if (PIND.2==0) {goto konec;}
   // 2
   if (InversP2==1) {PORTC.2=0;}
   else {PORTC.2=1;}                      
   
  //    P1
   for (i=1; i<=((PauseP1stop-PauseP2stop)/100); i=i+1)
   {
    delay_ms(100);  
    if (PIND.2==0) {goto konec;}
   }
   // 1 
   if (InversP1==1) {PORTC.1=0;}
   else {PORTC.1=1;}                       
  }  
     
//  TCCR0=0x05;  // 1
 konec:;
 }
}
               
// Timer 0 overflow interrupt service routine
interrupt [TIM0_OVF] void timer0_ovf_isr(void)    //  15 
{
// Reinitialize Timer 0 value
TCNT0=0x15;
// Place your code here  
ADCSRA.6=1; // 
}

// ADC interrupt service routine
interrupt [ADC_INT] void adc_isr(void)
{
//unsigned int adc_data;
// Read the AD conversion result
adc_data[input_index]=ADCW;
// Place your code here  

//OCR1B = adc_data;  //   
//if (input_index==0) {OCR1B=((1023.0-PWMnach)/1023.0)*adc_data[input_index]+PWMnach;}

//    
if (input_index==0)
  {
   input_index=4;
   // External Interrupt(s) initialization
   // INT0: Off
   // INT1: Off
   MCUCR=0x00;}
else 
  {input_index=0;
 // External Interrupt(s) initialization
// INT0: Off
// INT1: On
// INT1 Mode: Rising Edge
GICR|=0x80;
MCUCR=0x0C;
GIFR=0x80;}
   
ADMUX=(0 | (ADC_VREF_TYPE & 0xff) )+input_index;
}
      
// External Interrupt 1 service routine
interrupt [EXT_INT1] void ext_int1_isr(void)  //    
{
// Place your code here
if (input_index==0) {     
                     OCR1B=((1023.0-PWMnach)/1023.0)*adc_data[input_index]+PWMnach;
                     //delta=adc_data[0]-adc_data[4];
                     //if (delta>=0) {OCR1B=((1023.0-PWMnach)/1023.0)*(adc_data[4]/*+delta*/)+PWMnach;}
                     //else {OCR1B=((1023.0-PWMnach)/1023.0)*(adc_data[4]/*+delta*/)+PWMnach;}  
                    } 
   // External Interrupt(s) initialization
   // INT0: Off
   // INT1: Off
   MCUCR=0x00;                                 
}

void main(void)
{
// Input/Output Ports initialization
// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=Out Func1=Out Func0=Out 
// State7=T State6=T State5=P State4=P State3=P State2=0 State1=1 State0=1 
PORTB=0x3B;
DDRB=0x07;

// Port C initialization
// Func6=In Func5=In Func4=In Func3=Out Func2=Out Func1=Out Func0=In 
// State6=P State5=P State4=T State3=0 State2=0 State1=0 State0=T 
PORTC=0x60;
DDRC=0x0E;

// Port D initialization
// Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=Out 
// State7=0 State6=0 State5=0 State4=0 State3=P State2=P State1=0 State0=0 
PORTD=0x0C;
DDRD=0xF3;

// Timer/Counter 0 initialization
// Clock source: System Clock
// Clock value: 15,625 kHz
TCCR0=0x05;
TCNT0=0x15;

// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 16000,000 kHz
// Mode: Fast PWM top=03FFh
// OC1A output: Discon.
// OC1B output: Non-Inv.
// Noise Canceler: Off
// Input Capture on Falling Edge
// Timer 1 Overflow Interrupt: Off
// Input Capture Interrupt: Off
// Compare A Match Interrupt: Off
// Compare B Match Interrupt: Off
TCCR1A=0x03;
TCCR1B=0x09;
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;

OCR1BH=0x00;
OCR1BL=0x00;

// Timer/Counter 2 initialization
// Clock source: System Clock
// Clock value: Timer 2 Stopped
// Mode: Normal top=FFh
// OC2 output: Disconnected
ASSR=0x00;
TCCR2=0x00;
TCNT2=0x00;
OCR2=0x00;

// External Interrupt(s) initialization
// INT0: Off
// INT1: Off
MCUCR=0x00;

// Timer(s)/Counter(s) Interrupt(s) initialization
TIMSK=0x01;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
ACSR=0x80;
SFIOR=0x00;

// ADC initialization
// ADC Clock frequency: 125,000 kHz
// ADC Voltage Reference: AREF pin
ADMUX=ADC_VREF_TYPE;
ADCSRA=0x8F;

// Global enable interrupts
#asm("sei")
            
if (k<=0) {k=1;}
if (k>=100) {k=99;}
PWMnach=(1023.0/100.0)*PWMstart;

while (1)
      {
      // Place your code here
      Display();    
      if (PIND.2==0) {pusk();}
      else {stop();}

      }; 
}       